#!/usr/bin/env python
# coding: utf-8

"""
14.1 기계학습의 단계
(p.251 ~ p.256)
"""

# In[1]: p.252
import numpy as np
import matplotlib.pyplot as plt
dogs = 1000 # 1000마리
cats = 1000
dog_height = 35 + (5 * np.random.randn(dogs))
cat_height = 30 + (5 * np.random.randn(cats))
plt.xlabel('Height')
plt.ylabel('Number of Species')
plt.hist([dog_height, cat_height], label=['Dogs', 'Cats'], stacked=True, color=['r', 'y'])
plt.legend()
plt.show()


# In[2]: p.254
features = [[270, "울퉁불퉁"], [250, "울퉁불퉁"], [220, "매끈"], [240, "매끈"]]
labels = ["오렌지", "오렌지", "사과", "사과"]


# In[3]: p.255
features = [[270, 0], [250, 0], [220, 1], [240, 1]]
labels = [0, 0, 1, 1]


# In[4]:
from sklearn import tree
features = [[270, 0], [250, 0], [220, 1], [240, 1]]
labels = [0, 0, 1, 1]  # 오렌지(0), 사과(1)
clf = tree.DecisionTreeClassifier()
clf = clf.fit(features, labels)


# In[5]: p.256
print(clf.predict([[245, 1]]))  # 질문: 무게가 245g이고 표면 상태가 '매끈'한 것(과일)은?

