#!/usr/bin/env python
# coding: utf-8

"""
16.2 문제 유형별 딥러닝 모델
<1> 이진분류 모델
(p.319 ~ p.327)
"""

# In[1]:  p.320
import matplotlib.pyplot as plt
from sklearn.datasets import make_blobs
data, labels = make_blobs(n_samples=10000, n_features=2, centers=2, random_state=0)
plt.scatter(data[:,0], data[:,1], c=labels)
plt.show()


# In[2]: p.322
print(data[:5])
print(labels[:5])


# In[3]:
from sklearn.model_selection import train_test_split
X_train, X_test, y_train, y_test = train_test_split(data, labels, test_size=0.2)


# In[4]: p.323
from keras import models
from keras import layers
model = models.Sequential()
model.add(layers.Dense(1, input_dim=2, activation='sigmoid'))


# In[5]:
model.summary()


# In[6]: p.324
from tensorflow.keras import models
from tensorflow.keras import layers


# In[7]:
model.compile(optimizer='SGD', loss='binary_crossentropy', metrics=['accuracy'])


# In[8]: p.325
model.fit(X_train, y_train, epochs=40, batch_size=100)


# In[9]:
result = model.evaluate(X_test, y_test)
result


# In[10]:
weights, bias = model.get_weights()
print(weights)
print(bias)


# In[11]: p.326
a = -(weights[0]/weights[1])/(weights[0]/bias)
b = -weights[0]/weights[1]


# In[12]:
import numpy as np
x = np.linspace(np.amin(X_train[:,0]), np.amax(X_train[:,0]))
plt.figure()
y = [a*i + b for i in x]
plt.plot(x, y, color='red', label='Boundary')
plt.scatter(X_train[:, 0], X_train[:, 1], c=y_train, s=20)
plt.legend()


# In[13]:
test = np.array([[2, -2], [2, 2.5], [2, 4]])
pred = model.predict(test)
print(pred)

