#!/usr/bin/env python
# coding: utf-8

"""
16.2 문제 유형별 딥러닝 모델
<2> 다중분류 모델
(p.327 ~ p.333)
"""

# In[1]: p.327
from sklearn import datasets
iris = datasets.load_iris()
X = iris.data
y = iris.target
from sklearn.model_selection import train_test_split
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.2)


# In[2]: p.328
from keras.utils.np_utils import to_categorical
y_train = to_categorical(y_train)
y_test = to_categorical(y_test)


# In[3]:
print(y_train[0])


# In[4]: p.329
from tensorflow.keras import models
from tensorflow.keras import layers
model = models.Sequential()
model.add(layers.Dense(2, input_shape=(4, )))
model.add(layers.Dense(3, activation='softmax'))


# In[5]: p.330
model.summary()


# In[6]: p.331
model.compile(optimizer='rmsprop', loss='categorical_crossentropy')


# In[7]:
history = model.fit(X_train, y_train, epochs=100)


# In[8]:
results = model.evaluate(X_test, y_test)


# In[9]: p.332
prediction = model.predict(X_test[0])
print(prediction)


# In[10]:
print(X_test[:1])
prediction = model.predict(X_test[:1])
print(prediction)

