#!/usr/bin/env python
# coding: utf-8

"""
16.2 문제 유형별 딥러닝 모델
<3> 회귀 모델
(p.333 ~ p.339)
"""

# In[1]: p.334
import pandas as pd
column_names = ['연비', '기통수', '배기량', '마력', '중량', '가속력', '연식', '제조국가']
dataset = pd.read_csv('automobile.csv', names=column_names, comment='\t', sep=" ", skipinitialspace=True)
dataset.head(3)


# In[2]:
dataset.isnull().sum()


# In[3]: p.335
dataset = dataset.dropna()


# In[4]: p.336
dataset.pop('제조국가')
dataset.head(3)


# In[5]:
len(dataset.index)


# In[6]:
train_data = dataset.sample(350)
len(train_data.index)


# In[7]:
test_data = dataset.drop(train_data.index)
len(test_data.index)


# In[8]: p.337
y_train = train_data['연비']
y_test = test_data['연비']
y_test.head(3)


# In[9]:
train_data.pop('연비')
test_data.pop('연비')
train_data[:3]


# In[10]:
from tensorflow.keras import models
from tensorflow.keras import layers
model = models.Sequential()
model.add(layers.Dense(32, activation='relu', input_dim=len(train_data.keys())))
model.add(layers.Dense(64, activation='relu'))
model.add(layers.Dense(1))


# In[11]: p.338
model.summary()


# In[12]:
model.compile(optimizer='rmsprop', loss='mse', metrics=['mae'])


# In[13]: p.339
history = model.fit(train_data, y_train, validation_split=0.2, epochs=200)


# In[14]:
mse, mae = model.evaluate(train_data, y_train)


# In[15]:
test_data[:1]


# In[16]:
prediction = model.predict(test_data[:1])
print('예측: ', prediction)
print('MAE: ', mae)

