#!/usr/bin/env python
# coding: utf-8

"""
16.4 이미지와 시계열 처리모델
<3> 순환 신경망
(p.368 ~ p.353)
"""

# In[1]: p.369
import pandas as pd
dataset = pd.read_csv('airline-passengers.csv', engine='python')


# In[2]: p.370
dataset.pop('Month')
dataset.columns = ['Passengers']
dataset = dataset.dropna()

from sklearn.preprocessing import MinMaxScaler
scaled = MinMaxScaler()
dataset = scaled.fit_transform(dataset)


# In[3]:
train = dataset[:120]
test = dataset[120:]


# In[4]:
def create_seq(data, lookback=1):
    X_data = []
    y_data = []
    for i in range(len(data)-lookback-1):
        add = data[i:(i+lookback), 0]
        X_data.append(add)
        y_data.append(data[i + lookback, 0])
    return np.array(X_data), np.array(y_data)

import numpy as np
lookback = 1
X_train, y_train = create_seq(train, lookback)
X_test, y_test = create_seq(test, lookback)

X_train = np.reshape(X_train, (X_train.shape[0], 1, X_train.shape[1]))
X_test = np.reshape(X_test, (X_test.shape[0], 1, X_test.shape[1]))


# In[5]:
from tensorflow.keras.models import Sequential
from tensorflow.keras.layers import Dense, LSTM
model = Sequential()
model.add(LSTM(4, input_shape=(1, lookback)))
model.add(Dense(1))


# In[6]:
model.compile(optimizer='rmsprop', loss='mse', metrics=['mae'])

epochs=30
history = model.fit(X_train, y_train, epochs=epochs, validation_split=0.2, batch_size=1)


# In[7]: p.371
import matplotlib.pyplot as plt
history_dict = history.history
plt.clf()
epoch_range = range(1, epochs+1)
plt.plot(epoch_range, history_dict['loss'], 'b', label='Trainingloss')
plt.plot(epoch_range, history_dict['val_loss'], 'b:', label='validation loss')
plt.axis([-0.3, 10, 0, 0.3])
plt.title('Training and validation loss')
plt.xlabel('Epochs')
plt.ylabel('Loss')
plt.legend()
plt.show()

